<?php

namespace App\Controllers;

use CodeIgniter\Controller;
use App\Models\CrudModel;
use App\Models\AlumniModel;

class Admin extends Controller {

	public $session;
	public $db;
	public $crudModel;
	public $alumniModel;

	public function __construct()
	{

		helper(['form','multi_language', 'download']);
		$this->session = \Config\Services::session();
		$this->db = \Config\Database::connect();
		$this->crudModel = new CrudModel();
		$this->alumniModel = new AlumniModel();

	}

	public function index()
	{

		if ($this->session->get('admin_login') == 1) return redirect()->to(base_url(). '/admin/dashboard');

	}

	public function download($filename = "") {
    // load download helder
    // helper(['download']);
    // read file contents
    $data = file_get_contents(base_url() . '/upload/librarian_image/'.$filename);
		if($filename == '') {
			$this->session->setFlashdata('error_message', 'File Does Not Exist', 3);
			return redirect()->to(base_url().'/admin/librarian');
		}
    return $this->response->download($filename, $data);
}

	public function dashboard()
	{
		$page_data[] = '';

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());
       	$page_data['page_name'] = 'dashboard';
        $page_data['page_title'] = get_phrase('admin_dashboard');
        return view('backend/index', $page_data);
	}

	public function manage_profile($param1 = '', $param2 = '', $param3 = '') 
	{
		$page_data = [];
		$data = [];
		$page_data['validation'] = null;

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

        if($param1 == 'update') {

        	if($this->request->getMethod() == 'post') {

        			$first_name = $this->request->getVar('first_name');
					$email = $this->request->getVar('email');				


					$credential = [
					'first_name' => $first_name,
					'email' => $email,
					];

					$admin_id = $this->session->get('admin_id');

					$row = $this->crudModel->update_profile($credential, $admin_id);
					// move_uploaded_file($_FILES['userfile']['tmp_name'], 'upload/admin_image/' . $id . '.jpg');
					// For Image Upload
					$move = ROOTPATH . "public/uploads/admin_image/" . $admin_id . '.jpg';

					if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

					} 

					if($row) {

						$this->session->setFlashdata('flash_message', 'Info Updated');
				    	return redirect()->to(base_url().'/admin/manage_profile');
					}

						

        	}
        }

        if($param1 == 'change_password') {

        	if($this->request->getMethod() == 'post') {

        		$rules = [

        			'new_password' => [

        				'label' => 'New Password',
        				'rules' => 'required',

        			],

        			'confirm_new_password' => [

        				'label' => 'Confirm Password',
        				'rules' => 'required|matches[new_password]',
        			],

        		];

        		if($this->validate($rules)) {

        			$userdata = [

        				'password' => password_hash($this->request->getVar('new_password'), PASSWORD_DEFAULT),
        			];

        			
        			$account_type = session()->get('login_type');
        			$account_id   = $account_type . '_id';

        			$status = $this->crudModel->change_password($account_type, $account_id, $this->session->get($account_id), $userdata);

        			if($status) {

        				$this->session->setFlashdata('flash_message', 'Password Updated', 3);
				    	return redirect()->to(base_url().'/admin/manage_profile');
        			}else {
        				
        				$this->session->setFlashdata('error_message', 'Failed to Update Password', 3);
				    	return redirect()->to(base_url().'/admin/manage_profile');
        			}

        		}else {

        			$page_data['validation'] = $this->validator;
        			// $this->session->setTempdata('error', 'Failed to validate. Please try again', 3);
        		}
        	}
        }

        $page_data['page_name'] = 'manage_profile';
		$page_data['edit_profile'] = $this->db->table('admin')->where('admin_id', $this->session->get('admin_id'))->get()->getResult();
        $page_data['page_title'] = get_phrase('manage_profile');
        return view('backend/index', $page_data);

		
	}

	public function enquiry_category($param1 = '', $param2 = '', $param3 = '')
	{
		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());
		if($param1 == 'insert') {

			$page_data['category'] = $this->request->getVar('category');
			$page_data['purpose'] = $this->request->getVar('purpose');
			$page_data['whom'] = $this->request->getVar('whom');

			$status = $this->crudModel->enquiry_category_insert($page_data);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Saved Successfully', 3);
				return redirect()->to(base_url().'/admin/enquiry_category');
			}

			
		}
		

		if($param1 == 'update') {

			$page_data['category'] = $this->request->getVar('category');
			$page_data['purpose'] = $this->request->getVar('purpose');
			$page_data['whom'] = $this->request->getVar('whom');

			$status = $this->crudModel->enquiry_category_update($page_data, $param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/enquiry_category');
			}

			

		}

		if($param1 == 'delete') {

			$status = $this->crudModel->enquiry_category_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/enquiry_category');
			}	

		}

		$page_data['page_name'] = 'enquiry_category';
		$page_data['enquiry_category'] = $this->db->table('enquiry_category')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_category');
        return view('backend/index', $page_data);

	}

	public function list_enquiry($param1 = '', $param2 = '', $param3 = '') {

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'delete') {

			$status = $this->crudModel->list_enquiry_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/list_enquiry');
			}
		}

		$page_data['page_name'] = 'list_enquiry';
		$page_data['select_enquiry'] = $this->db->table('enquiry')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('all_enquiries');
        return view('backend/index', $page_data);
	}

	public function club($param1 = '', $param2 = '', $param3 = '')
	{
		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			$page_data['club_name'] = $this->request->getVar('club_name');
			$page_data['desc'] = $this->request->getVar('desc');
			$page_data['date'] = $this->request->getVar('date');

			$status = $this->crudModel->club_insert($page_data);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/club');
			}		
		}


		if($param1 == 'update') {

			$page_data['club_name'] = $this->request->getVar('club_name');
			$page_data['desc'] = $this->request->getVar('desc');
			$page_data['date'] = $this->request->getVar('date');

			$status = $this->crudModel->club_update($page_data, $param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/club');
			}		
		}


		if($param1 == 'delete') {

			$status = $this->crudModel->club_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/club');
			}		
		}


		$page_data['page_name'] = 'club';
		$page_data['select_club'] = $this->db->table('club')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_club');
        return view('backend/index', $page_data);
	}

	public function circular($param1 = '', $param2 = '', $param3 = '')
	{
		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			$page_data['title'] = $this->request->getVar('title');
			$page_data['reference'] = $this->request->getVar('reference');
			$page_data['content'] = $this->request->getVar('content');
			$page_data['date'] = $this->request->getVar('date');

			$status = $this->crudModel->circular_insert($page_data);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/circular');
			}		
		}

		if($param1 == 'update') {

			$page_data['title'] = $this->request->getVar('title');
			$page_data['reference'] = $this->request->getVar('reference');
			$page_data['content'] = $this->request->getVar('content');
			$page_data['date'] = $this->request->getVar('date');

			$status = $this->crudModel->circular_update($page_data, $param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/circular');
			}		
		}

		if($param1 == 'delete') {

			$status = $this->crudModel->circular_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/circular');
			}		
		}


		$page_data['page_name'] = 'circular';
		$page_data['select_circular'] = $this->db->table('circular')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_circular');
        return view('backend/index', $page_data);

	}

	public function parent($param1 = '', $param2 = '', $param3 = '')
	{

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			$page_data['name'] = $this->request->getVar('name');
			$page_data['email'] = $this->request->getVar('email');
			$page_data['phone'] = $this->request->getVar('phone');
			$page_data['profession'] = $this->request->getVar('profession');
			$page_data['address'] = $this->request->getVar('address');
			$page_data['password'] = password_hash($this->request->getVar('password'), PASSWORD_DEFAULT);


			$status = $this->crudModel->parent_insert($page_data);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/parent');
			}		
		}

		if($param1 == 'update') {

			$page_data['name'] = $this->request->getVar('name');
			$page_data['email'] = $this->request->getVar('email');
			$page_data['phone'] = $this->request->getVar('phone');
			$page_data['profession'] = $this->request->getVar('profession');
			$page_data['address'] = $this->request->getVar('address');

			$status = $this->crudModel->parent_update($page_data, $param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/parent');
			}		
		}

		if($param1 == 'delete') {

			$status = $this->crudModel->parent_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/parent');
			}		
		}
		
		$page_data['page_name'] = 'parent';
		$page_data['select_parent'] = $this->db->table('parent')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_parent');
        return view('backend/index', $page_data);
	}

	public function librarian($param1 = '', $param2 = '', $param3 = '')
	{

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			if($this->request->getMethod() == 'post') {

				$rules = [
	                'name' 					=> 'required',
	                // 'birthday' 				=> 'required',
	                // 'sex' 					=> 'required',
	                // 'religion' 				=> 'required',
	                // 'blood_group' 			=> 'required',
	                // 'address' 				=> 'required',
	                // 'phone' 				=> 'required',
	                // 'qualification' 		=> 'required',
	                // 'email' 				=> 'required|is_unique[librarian.email]',
	                // 'marital_status' 		=> 'required',
	                // 'password' 				=> 'required',
            ];

            if($this->validate($rules)) {

            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'librarian_number' 	=> $this->request->getVar('librarian_number'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['file_name'] = $_FILES['file']['name'];
			$page_data['email'] = $this->request->getVar('email');

			$check_email = $this->crudModel->checkEmail($page_data['email']);

			if($check_email != null) {

				$this->session->setFlashdata('flash_message', 'Email Already Exist', 3);
				return redirect()->to(base_url().'/admin/librarian');

			}else {

				$status = $this->crudModel->librarian_insert($page_data);

				$librarian_id = $this->db->insertID();

					
				// For Document Upload
				move_uploaded_file($_FILES["file"]["tmp_name"], "public/uploads/librarian_image/" . $_FILES["file"]["name"]);

				// For Image Upload
				$move = ROOTPATH . "public/uploads/librarian_image/" . $librarian_id . '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				} 

				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/librarian');

				}
				

				$this->email_model->account_opening_email('librarian', $page_data['email']);
			}

          } else {

          		$page_data['validation'] = $this->validator;
          		$this->session->set('error', 'Failed to validate. Please try again', 3);
          }

		}
			
	}

		if($param1 == 'update') {


            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['email'] = $this->request->getVar('email');

			$status = $this->crudModel->librarian_update($page_data, $param2);

			// For Image Upload
				$move = ROOTPATH . "public/uploads/librarian_image/" . $param2. '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				}


				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/librarian');

				}			

			}
			

		if($param1 == 'delete') {

			$status = $this->crudModel->librarian_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/librarian');
			}		
		}
		
		$page_data['page_name'] = 'librarian';
		$page_data['select_librarian'] = $this->db->table('librarian')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_librarian');
        return view('backend/index', $page_data);
	}



	public function accountant($param1 = '', $param2 = '', $param3 = '')
	{

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			if($this->request->getMethod() == 'post') {

				$rules = [
	                'name' 					=> 'required',
	                // 'birthday' 				=> 'required',
	                // 'sex' 					=> 'required',
	                // 'religion' 				=> 'required',
	                // 'blood_group' 			=> 'required',
	                // 'address' 				=> 'required',
	                // 'phone' 				=> 'required',
	                // 'qualification' 		=> 'required',
	                // 'email' 				=> 'required|is_unique[librarian.email]',
	                // 'marital_status' 		=> 'required',
	                // 'password' 				=> 'required',
            ];

            if($this->validate($rules)) {

            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'accountant_number' => $this->request->getVar('accountant_number'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['file_name'] = $_FILES['file']['name'];
			$page_data['email'] = $this->request->getVar('email');

			$login_type = session()->get('login_type');
			$check_email = $this->crudModel->checkEmail($login_type, $page_data['email']);

			if($check_email != null) {

				$this->session->setFlashdata('flash_message', 'Email Already Exist', 3);
				return redirect()->to(base_url().'/admin/accountant');

			}else {

				$status = $this->crudModel->accountant_insert($page_data);

				$accountant_id = $this->db->insertID();

					
				// For Document Upload
				move_uploaded_file($_FILES["file"]["tmp_name"], "public/uploads/accountant_image/" . $_FILES["file"]["name"]);

				// For Image Upload
				$move = ROOTPATH . "public/uploads/accountant_image/" . $accountant_id . '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				} 

				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/accountant');

				}
				

				$this->email_model->account_opening_email('accountant', $page_data['email']);
			}

          } else {

          		$page_data['validation'] = $this->validator;
          		$this->session->set('error', 'Failed to validate. Please try again', 3);
          }

		}
			
	}

		if($param1 == 'update') {


            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['email'] = $this->request->getVar('email');

			$status = $this->crudModel->accountant_update($page_data, $param2);

			// For Image Upload
				$move = ROOTPATH . "public/uploads/accountant_image/" . $param2. '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				}


				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/accountant');

				}			

			}
			

		if($param1 == 'delete') {

			$status = $this->crudModel->accountant_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/accountant');
			}		
		}
		
		$page_data['page_name'] = 'accountant';
		$page_data['select_accountant'] = $this->db->table('accountant')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_accountant');
        return view('backend/index', $page_data);
	}



	public function hostel($param1 = '', $param2 = '', $param3 = '')
	{

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			if($this->request->getMethod() == 'post') {

				$rules = [
	                'name' 					=> 'required',
	                // 'birthday' 				=> 'required',
	                // 'sex' 					=> 'required',
	                // 'religion' 				=> 'required',
	                // 'blood_group' 			=> 'required',
	                // 'address' 				=> 'required',
	                // 'phone' 				=> 'required',
	                // 'qualification' 		=> 'required',
	                // 'email' 				=> 'required|is_unique[librarian.email]',
	                // 'marital_status' 		=> 'required',
	                // 'password' 				=> 'required',
            ];

            if($this->validate($rules)) {

            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'hostel_number' 	=> $this->request->getVar('hostel_number'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['file_name'] = $_FILES['file']['name'];
			$page_data['email'] = $this->request->getVar('email');

			$login_type = session()->get('login_type');
			$check_email = $this->crudModel->checkEmail($login_type, $page_data['email']);

			if($check_email != null) {

				$this->session->setFlashdata('flash_message', 'Email Already Exist', 3);
				return redirect()->to(base_url().'/admin/hostel');

			}else {

				$status = $this->crudModel->hostel_insert($page_data);

				$accountant_id = $this->db->insertID();

					
				// For Document Upload
				move_uploaded_file($_FILES["file"]["tmp_name"], "public/uploads/hostel_image/" . $_FILES["file"]["name"]);

				// For Image Upload
				$move = ROOTPATH . "public/uploads/hostel_image/" . $accountant_id . '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				} 

				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/hostel');

				}
				

				$this->email_model->account_opening_email('hostel', $page_data['email']);
			}

          } else {

          		$page_data['validation'] = $this->validator;
          		$this->session->set('error', 'Failed to validate. Please try again', 3);
          }

		}
			
	}

		if($param1 == 'update') {


            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['email'] = $this->request->getVar('email');

			$status = $this->crudModel->hostel_update($page_data, $param2);

			// For Image Upload
				$move = ROOTPATH . "public/uploads/hostel_image/" . $param2. '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				}


				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/hostel');

				}			

			}
			

		if($param1 == 'delete') {

			$status = $this->crudModel->hostel_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/hostel');
			}		
		}
		
		$page_data['page_name'] = 'hostel';
		$page_data['select_hostel'] = $this->db->table('hostel')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_hostel');
        return view('backend/index', $page_data);
	}




	public function hrm($param1 = '', $param2 = '', $param3 = '')
	{

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			if($this->request->getMethod() == 'post') {

				$rules = [
	                'name' 					=> 'required',
	                // 'birthday' 				=> 'required',
	                // 'sex' 					=> 'required',
	                // 'religion' 				=> 'required',
	                // 'blood_group' 			=> 'required',
	                // 'address' 				=> 'required',
	                // 'phone' 				=> 'required',
	                // 'qualification' 		=> 'required',
	                // 'email' 				=> 'required|is_unique[librarian.email]',
	                // 'marital_status' 		=> 'required',
	                // 'password' 				=> 'required',
            ];

            if($this->validate($rules)) {

            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'hrm_number' 	=> $this->request->getVar('hrm_number'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['file_name'] = $_FILES['file']['name'];
			$page_data['email'] = $this->request->getVar('email');

			$login_type = session()->get('login_type');
			$check_email = $this->crudModel->checkEmail($login_type, $page_data['email']);

			if($check_email != null) {

				$this->session->setFlashdata('flash_message', 'Email Already Exist', 3);
				return redirect()->to(base_url().'/admin/hrm');

			}else {

				$status = $this->crudModel->hrm_insert($page_data);

				$hrm_id = $this->db->insertID();

					
				// For Document Upload
				move_uploaded_file($_FILES["file"]["tmp_name"], "public/uploads/hrm_image/" . $_FILES["file"]["name"]);

				// For Image Upload
				$move = ROOTPATH . "public/uploads/hrm_image/" . $hrm_id . '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				} 

				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/hrm');

				}
				

				$this->email_model->account_opening_email('hostel', $page_data['email']);
			}

          } else {

          		$page_data['validation'] = $this->validator;
          		$this->session->set('error', 'Failed to validate. Please try again', 3);
          }

		}
			
	}

		if($param1 == 'update') {


            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['email'] = $this->request->getVar('email');

			$status = $this->crudModel->hrm_update($page_data, $param2);

			// For Image Upload
				$move = ROOTPATH . "public/uploads/hrm_image/" . $param2. '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				}


				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/hrm');

				}			

			}
			

		if($param1 == 'delete') {

			$status = $this->crudModel->hrm_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/hrm');
			}		
		}
		
		$page_data['page_name'] = 'hrm';
		$page_data['select_hrm'] = $this->db->table('hrm')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_hrm');
        return view('backend/index', $page_data);
	}



	public function alumni($param1 = '', $param2 = '', $param3 = '')
	{

		if ($this->session->get('admin_login') != 1) return redirect()->to(base_url());

		if($param1 == 'insert') {

			if($this->request->getMethod() == 'post') {

				$rules = [
	                'name' 					=> 'required',
	                // 'birthday' 				=> 'required',
	                // 'sex' 					=> 'required',
	                // 'religion' 				=> 'required',
	                // 'blood_group' 			=> 'required',
	                // 'address' 				=> 'required',
	                // 'phone' 				=> 'required',
	                // 'qualification' 		=> 'required',
	                // 'email' 				=> 'required|is_unique[librarian.email]',
	                // 'marital_status' 		=> 'required',
	                // 'password' 				=> 'required',
            ];

            if($this->validate($rules)) {

            	$page_data = [

				'name' 					=> $this->request->getVar('name'),
				'sex' 					=> $this->request->getVar('sex'),
				'phone' 				=> $this->request->getVar('phone'),
				'email' 				=> $this->request->getVar('email'),
				'address' 				=> $this->request->getVar('address'),
				'profession' 			=> $this->request->getVar('profession'),
				'marital_status' 		=> $this->request->getVar('marital_status'),
				'g_year' 				=> $this->request->getVar('g_year'),
				'club' 					=> $this->request->getVar('club_id'),
				'interest' 				=> $this->request->getVar('interest'),
				'club' 					=> $this->request->getVar('club_id'),

			];

			// $page_data['file_name'] = $_FILES['file']['name'];
			$page_data['email'] = $this->request->getVar('email');

			$check_email = $this->alumniModel->checkEmail($page_data['email']);

			if($check_email != null) {

				$this->session->setFlashdata('flash_message', 'Email Already Exist', 3);
				return redirect()->to(base_url().'/admin/alumni');

			}else {

				$status = $this->alumniModel->alumni_insert($page_data);

				$alumni_id = $this->db->insertID();

				// For Document Upload
				move_uploaded_file($_FILES["userfile"]["tmp_name"], "public/uploads/alumni_image/" . $_FILES["userfile"]["name"]);

				// For Image Upload
				$move = ROOTPATH . "public/uploads/alumni_image/" . $alumni_id . '.jpg';

				if (move_uploaded_file($_FILES['userfile']['tmp_name'], $move)) {

				} 

				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Inserted Successfully', 3);
				return redirect()->to(base_url().'/admin/alumni');

				}
				

				$this->email_model->account_opening_email('hostel', $page_data['email']);
			}

          } else {

          		$page_data['validation'] = $this->validator;
          		$this->session->set('error', 'Failed to validate. Please try again', 3);
          }

		}
			
	}

		if($param1 == 'update') {


            	$page_data = [

				'name' 				=> $this->request->getVar('name'),
				'birthday' 			=> $this->request->getVar('birthday'),
				'sex' 				=> $this->request->getVar('sex'),
				'religion' 			=> $this->request->getVar('religion'),
				'blood_group' 		=> $this->request->getVar('blood_group'),
				'address' 			=> $this->request->getVar('address'),
				'phone' 			=> $this->request->getVar('phone'),												
				'facebook' 			=> $this->request->getVar('facebook'),
				'twitter' 			=> $this->request->getVar('twitter'),
				'googleplus' 		=> $this->request->getVar('googleplus'),
				'linkedin' 			=> $this->request->getVar('linkedin'),
				'qualification' 	=> $this->request->getVar('qualification'),
				'marital_status' 	=> $this->request->getVar('marital_status'),
				'password' 			=> password_hash($this->request->getVar('password'), PASSWORD_DEFAULT),

			];

			$page_data['email'] = $this->request->getVar('email');

			$status = $this->alumniModel->alumni_update($page_data, $param2);


				if($status) {

				$this->session->setFlashdata('flash_message', 'Data Updated Successfully', 3);
				return redirect()->to(base_url().'/admin/alumni');

				}			

			}
			

		if($param1 == 'delete') {

			$status = $this->alumniModel->alumni_delete($param2);

			if($status) {

				$this->session->setFlashdata('flash_message', 'Data Deleted Successfully', 3);
				return redirect()->to(base_url().'/admin/alumni');
			}		
		}
		
		$page_data['page_name'] = 'alumni';
		$page_data['select_alumni'] = $this->db->table('alumni')->get()->getResultArray();
        $page_data['page_title'] = get_phrase('manage_alumni');
        return view('backend/index', $page_data);
	}



}