<?php 

namespace App\Controllers;

use CodeIgniter\Controller;
use App\Models\loginModel;


class Login extends Controller {

	public $loginModel; 
	public $session;
	public $db;

	public function __construct() {

		helper(['form','multi_language']);
		$this->session = \Config\Services::session();
		$this->loginModel = new LoginModel();
		$this->db = \Config\Database::connect();

	}

	public function index() {

		if ($this->session->get('admin_login') == 1) return redirect()->to(base_url(). '/admin/dashboard');
		return view('backend/login');
	}

	public function check_login() {
		
		if($this->request->getMethod() == 'post') {

			 $rules = [
                'email' => 'required|valid_email',
                'password' => 'required|min_length[4]|max_length[16]',
            ];

            if($this->validate($rules)) {

            	$email = $this->request->getVar('email');
					$password = $this->request->getVar('password');

					// $credential = [
					// 'email' => $email,
					// 'password' => sha1($password),
					// ];

					// $row = $this->loginModel->adminLogin($credential);

					$userdata = $this->loginModel->verifyEmail($email);

					if($userdata) {

						if(password_verify($password, $userdata->password)) {

							$this->session->set('login_type', 'admin');
			            $this->session->set('admin_login', '1');
			            $this->session->set('admin_id', $userdata->admin_id);
			            $this->session->set('login_user_id', $userdata->admin_id);
			            $this->session->set('first_name', $userdata->first_name);			            
						}else {

							$this->session->setFlashdata('error_message', 'Wrong Password Entered');
			        		return redirect()->to(base_url().'/login');
						}
							$this->session->setFlashdata('flash_message', 'Successfully Login');
			        		return redirect()->to(base_url().'/admin/dashboard');
			        
		        }else {

		        		$this->session->setFlashdata('error_message', 'Wrong Email or Password');
			        return redirect()->to(base_url().'/login');
		        }

            }else {

            	$this->session->setFlashdata('error_message', 'Failed to validate');
			        return redirect()->to(base_url().'/login');
            }
			
			}   	
     }

     function logout(){

        $this->session->destroy();
        return redirect()->to(base_url(). '/login');
     }

}

















